<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc -->
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>ExpressionEngine (Apache Commons Configuration 2.2 API)</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="ExpressionEngine (Apache Commons Configuration 2.2 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":6,"i1":6,"i2":6,"i3":6,"i4":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/ExpressionEngine.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngineSymbols.Builder.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/tree/ExpressionEngine.html" target="_top">Frames</a></li>
<li><a href="ExpressionEngine.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.commons.configuration2.tree</div>
<h2 title="Interface ExpressionEngine" class="title">Interface ExpressionEngine</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Known Implementing Classes:</dt>
<dd><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html" title="class in org.apache.commons.configuration2.tree">DefaultExpressionEngine</a>, <a href="../../../../../org/apache/commons/configuration2/tree/xpath/XPathExpressionEngine.html" title="class in org.apache.commons.configuration2.tree.xpath">XPathExpressionEngine</a></dd>
</dl>
<hr>
<br>
<pre>public interface <span class="typeNameLabel">ExpressionEngine</span></pre>
<div class="block"><p>
 Definition of an interface for evaluating keys for hierarchical
 configurations.
 </p>
 <p>
 An <em>expression engine</em> knows how to map a key for a configuration's
 property to a single or a set of configuration nodes. Thus it defines the way
 how properties are addressed in this configuration. Methods of a
 configuration that have to handle property keys (e.g. <code>getProperty()</code>
 or <code>addProperty()</code> do not interpret the passed in keys on their own,
 but delegate this task to an associated expression engine. This expression
 engine will then find out, which configuration nodes are addressed by the
 key.
 </p>
 <p>
 Separating the task of evaluating property keys from the configuration object
 has the advantage that multiple different expression languages (i.e. ways for
 querying or setting properties) can be supported. Just set a suitable
 implementation of this interface as the configuration's expression engine,
 and you can use the syntax provided by this implementation.
 </p>
 <p>
 An <code>ExpressionEngine</code> can deal with nodes of different types. To
 achieve this, a <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree"><code>NodeHandler</code></a> for the desired type must be passed to
 the methods.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>1.3</dd>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>$Id: ExpressionEngine.java 1624601 2014-09-12 18:04:36Z oheger $</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#attributeKey-java.lang.String-java.lang.String-">attributeKey</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
            <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;attributeName)</code>
<div class="block">Returns the key of an attribute.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#canonicalKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">canonicalKey</a></span>(T&nbsp;node,
            <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
            <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Determines a &quot;canonical&quot; key for the specified node in the
 expression language supported by this implementation.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#nodeKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">nodeKey</a></span>(T&nbsp;node,
       <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
       <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Returns the key for the specified node in the expression language
 supported by an implementation.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/NodeAddData.html" title="class in org.apache.commons.configuration2.tree">NodeAddData</a>&lt;T&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#prepareAdd-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">prepareAdd</a></span>(T&nbsp;root,
          <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
          <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Returns information needed for an add operation.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;T&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#query-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">query</a></span>(T&nbsp;root,
     <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
     <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Finds the nodes and/or attributes that are matched by the specified key.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="query-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="query-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>query</h4>
<pre>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;T&gt;&gt;&nbsp;query(T&nbsp;root,
                               <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                               <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Finds the nodes and/or attributes that are matched by the specified key.
 This is the main method for interpreting property keys. An implementation
 must traverse the given root node and its children to find all results
 that are matched by the given key. If the key is not correct in the
 syntax provided by that implementation, it is free to throw a (runtime)
 exception indicating this error condition. The passed in
 <code>NodeHandler</code> can be used to gather the required information from
 the node object.</div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the node to be processed</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>root</code> - the root node of a hierarchy of nodes</dd>
<dd><code>key</code> - the key to be evaluated</dd>
<dd><code>handler</code> - the <code>NodeHandler</code> for accessing the node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a list with the results that are matched by the key (should never
         be <b>null</b>)</dd>
</dl>
</li>
</ul>
<a name="nodeKey-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="nodeKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>nodeKey</h4>
<pre>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;nodeKey(T&nbsp;node,
                   <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
                   <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Returns the key for the specified node in the expression language
 supported by an implementation. This method is called whenever a property
 key for a node has to be constructed, e.g. by the
 <a href="../../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getKeys--"><code>getKeys()</code></a> method.</div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the node to be processed</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - the node, for which the key must be constructed</dd>
<dd><code>parentKey</code> - the key of this node's parent (can be <b>null</b> for
        the root node)</dd>
<dd><code>handler</code> - the <code>NodeHandler</code> for accessing the node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this node's key</dd>
</dl>
</li>
</ul>
<a name="attributeKey-java.lang.String-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>attributeKey</h4>
<pre><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;attributeKey(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
                    <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;attributeName)</pre>
<div class="block">Returns the key of an attribute. The passed in <code>parentKey</code> must
 reference the parent node of the attribute. A concrete implementation
 must concatenate this parent key with the attribute name to a valid key
 for this attribute.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parentKey</code> - the key to the node owning this attribute</dd>
<dd><code>attributeName</code> - the name of the attribute in question</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the resulting key referencing this attribute</dd>
</dl>
</li>
</ul>
<a name="canonicalKey-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="canonicalKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>canonicalKey</h4>
<pre>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;canonicalKey(T&nbsp;node,
                        <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
                        <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Determines a &quot;canonical&quot; key for the specified node in the
 expression language supported by this implementation. This means that
 always a unique key if generated pointing to this specific node. For most
 concrete implementations, this means that an index is added to the node
 name to ensure that there are no ambiguities with child nodes having the
 same names.</div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the node to be processed</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - the node, for which the key must be constructed</dd>
<dd><code>parentKey</code> - the key of this node's parent (can be <b>null</b> for
        the root node)</dd>
<dd><code>handler</code> - the <code>NodeHandler</code> for accessing the node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the canonical key of this node</dd>
</dl>
</li>
</ul>
<a name="prepareAdd-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="prepareAdd-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>prepareAdd</h4>
<pre>&lt;T&gt;&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/NodeAddData.html" title="class in org.apache.commons.configuration2.tree">NodeAddData</a>&lt;T&gt;&nbsp;prepareAdd(T&nbsp;root,
                              <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                              <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Returns information needed for an add operation. This method gets called
 when new properties are to be added to a configuration. An implementation
 has to interpret the specified key, find the parent node for the new
 elements, and provide all information about new nodes to be added.</div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the node to be processed</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>root</code> - the root node</dd>
<dd><code>key</code> - the key for the new property</dd>
<dd><code>handler</code> - the <code>NodeHandler</code> for accessing the node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an object with all information needed for the add operation</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/ExpressionEngine.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngineSymbols.Builder.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/configuration2/tree/ImmutableNode.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/tree/ExpressionEngine.html" target="_top">Frames</a></li>
<li><a href="ExpressionEngine.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &#169; 2001&#x2013;2017 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</body>
</html>
